# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = ['IP']


class IP(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 reverse: Optional[pulumi.Input[str]] = None,
                 server: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        **DEPRECATED**: This resource is deprecated and will be removed in `v2.0+`.
        Please use `InstanceIP` instead.

        Provides IPs for servers. This allows IPs to be created, updated and deleted.
        For additional details please refer to [API documentation](https://developer.scaleway.com/#ips).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_scaleway as scaleway

        test_ip = scaleway.IP("testIp")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] reverse: Please us the IPReverseDNS resource instead.
        :param pulumi.Input[str] server: ID of server to associate IP with
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if reverse is not None:
                warnings.warn("use scaleway_ip_reverse_dns resource instead", DeprecationWarning)
                pulumi.log.warn("reverse is deprecated: use scaleway_ip_reverse_dns resource instead")
            __props__['reverse'] = reverse
            __props__['server'] = server
            __props__['ip'] = None
        super(IP, __self__).__init__(
            'scaleway:index/iP:IP',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ip: Optional[pulumi.Input[str]] = None,
            reverse: Optional[pulumi.Input[str]] = None,
            server: Optional[pulumi.Input[str]] = None) -> 'IP':
        """
        Get an existing IP resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip: IP of the new resource
        :param pulumi.Input[str] reverse: Please us the IPReverseDNS resource instead.
        :param pulumi.Input[str] server: ID of server to associate IP with
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["ip"] = ip
        __props__["reverse"] = reverse
        __props__["server"] = server
        return IP(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Output[str]:
        """
        IP of the new resource
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def reverse(self) -> pulumi.Output[str]:
        """
        Please us the IPReverseDNS resource instead.
        """
        return pulumi.get(self, "reverse")

    @property
    @pulumi.getter
    def server(self) -> pulumi.Output[str]:
        """
        ID of server to associate IP with
        """
        return pulumi.get(self, "server")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

